//
// Copyright 2002-2005 Aspose Pty Ltd. All Rights Reserved.
//
// This file is part of Aspose.Pdf for Java. The source code in this file
// is only intended as a supplement to the documentation, and is provided
// "as is", without warranty of any kind, either expressed or implied.
//
package samples.form;

import java.sql.*;
import java.util.*;
import com.aspose.pdf.kit.*;

//This demo shows how to fill the fields automatically from the designed database sources.
public class AutoFilling {

  public static void main(String[] args) {
    // record how many records are acquired from database
    int count = 0;
    //construct the vector of column names
    Vector columnName = new Vector();
    columnName.add("Name");
    columnName.add("Gender");
    columnName.add("Age");
    columnName.add("Address");

    Vector dataSource = null;

    try {
      //get data from mysql database, forming a vector consisting of vectors
      System.out.println("Test for database connecting.....");
      Connection connectionGet;
      Statement statementGet;
      ResultSet resultSetGet;
      String myJdbcURL =
          "jdbc:mysql://localhost/student?user=root&password=&useUnicode=true&characterEncoding=gb2312";
      try {
        Class.forName("org.gjt.mm.mysql.Driver").newInstance();
      }
      catch (Exception ex) {
        System.out.println("Unable to load driver.");
      }
      try {
        //connect to the database
        connectionGet = DriverManager.getConnection(myJdbcURL);
        statementGet = connectionGet.createStatement(ResultSet.
            TYPE_SCROLL_SENSITIVE,
            ResultSet.CONCUR_READ_ONLY);
        String sqlState = "USE student";
        int exeCode = statementGet.executeUpdate(sqlState);
        String query = "SELECT * FROM info";
        resultSetGet = statementGet.executeQuery(query);
        dataSource = new Vector();
        //get data from data source and construct the vector of dataSource
        while (resultSetGet.next()) {
          Vector tmpData = new Vector();
          tmpData.add(resultSetGet.getString(1));
          tmpData.add(resultSetGet.getString(2));
          tmpData.add(resultSetGet.getString(3));
          tmpData.add(resultSetGet.getString(4));

          dataSource.add(tmpData);
        }
        count = dataSource.size();
        resultSetGet.close();
        statementGet.close();
        connectionGet.close();
      }
      catch (SQLException sqlEx) {
        System.out.println("Cannot connect to database!");
      }

      //CASE 1: here we test the methods, produce output file(s).
      AutoFiller autoFiller = new AutoFiller(columnName, dataSource);
      ///uncomment the next line will produce a single big pdf file.
      //autoFiller.setGenMultiPdfs(false);

      ///set input and output file names like this:
      autoFiller.setBasicPath("./examples/samplePdfs/");
      autoFiller.setBasicFileName("output");
      autoFiller.setInputFile("autoFillerTest.pdf");

      ///set a field which will keep unflattened like this:
      autoFiller.unFlatten("Name");

      ///fill data into the template like this:
      autoFiller.importData( );

      ///close the opened files and streams like this:
      autoFiller.close();

/*
      //CASE 2: here we test the methods, produce output stream(s).
      AutoFiller autoFiller = new AutoFiller(columnName, dataSource);
      autoFiller.setBasicPath("./examples/samplePdfs/");
      autoFiller.setInputFile("autoFillerTest.pdf");
      ByteArrayOutputStream[] outputs = new ByteArrayOutputStream[count];
      for (int i = 0; i < 5; i++) {
        outputs[i] = new ByteArrayOutputStream();
      }
      autoFiller.setOutStreams(outputs);
      autoFiller.unFlatten("Name");
      autoFiller.importData();
      autoFiller.close();
*/
/*
     //CASE 3: here we test the methods, produce output stream(s).
     AutoFiller autoFiller = new AutoFiller(columnName, dataSource);
     autoFiller.setGenMultiPdfs(false);
     autoFiller.setBasicPath("./examples/samplePdfs/");
     autoFiller.setInputFile("autoFillerTest.pdf");
     FileOutputStream fileoutput = new FileOutputStream("test.pdf");
     BufferedOutputStream output = new BufferedOutputStream(fileoutput);
     autoFiller.setOutStream(output);
     autoFiller.unFlatten("Name");
     autoFiller.importData();
     autoFiller.close();
     output.close();
     fileoutput.close();
*/

      System.out.println("filling succeed!");
    }

    catch (Exception ex) {
      System.out.println("filling error!");
    }
  }
}
