//
//Copyright 2002-2005 Aspose Pty Ltd. All Rights Reserved.
//
//This file is part of Aspose.Pdf for Java. The source code in this file
//is only intended as a supplement to the documentation, and is provided
//"as is", without warranty of any kind, either expressed or implied.
//
package samples.search;

import java.awt.Rectangle;
import java.util.List;

import com.aspose.pdf.kit.License;

import com.aspose.pdf.kit.PdfSearcher;

/**
 * <p>
 * A simple example to extract raw text from a pdf file within a specified
 * rectangle.
 * </p>
 * 
 * <p>
 * Copyright: 2002-2005 . All Rights Reserved.
 * </p>
 * <p>
 * Company: Aspose Pty Ltd
 * </p>
 * 
 * @version 1.0.0.0
 */
public class SearchTextInRectangle {
	// setting the test pdf file's path here
	static String path = "./examples/resources/";

	public static void main(String[] args) {
		// If you got a license, uncomment following lines.
		// License lic = new License();
		// try
		// {
		// lic.setLicense(new FileInputStream(new
		// File("Aspose.Pdf.Kit.Java.Ent.lic")));
		// }
		// catch (Exception e) {
		// System.out.println(e.getMessage());
		// }

		try {
			PdfSearcher pdfsearcher = new PdfSearcher();
			String path = "./examples/resources/";
			pdfsearcher.bindPdf(path + "text.pdf");

			// the extract text rectangle.
			java.awt.Rectangle rec = new java.awt.Rectangle(0, 0, 1000, 1000);

			pdfsearcher.setStartPage(1);
			pdfsearcher.setEndPage(2);

			pdfsearcher.searchTextInRectangle(rec, "all");

			// gets the search results.
			// The first Object in the return Map is the page number in
			// searching ,and the second Object is the match points.
			java.util.Map result = pdfsearcher.getMatchText();

			for (int PageIndex = pdfsearcher.getStartPage(); PageIndex <= pdfsearcher
					.getEndPage(); PageIndex++) {
				java.util.List pagePoints = (java.util.List) result
						.get(new Integer(PageIndex));
				System.out.println("Search page number: " + PageIndex);
				for (int onePagePoints = 0; onePagePoints < pagePoints.size(); onePagePoints++) {
					java.awt.geom.Point2D tempPoint = (java.awt.geom.Point2D) pagePoints
							.get(onePagePoints);
					System.out.println("The match text point is "
							+ onePagePoints + " which position is ("
							+ tempPoint.getX() + "," + tempPoint.getY() + ")");
				}
				System.out.println("\n\n");
			}

		} catch (Exception ioe) {
			System.out.println(ioe.getMessage());
		}
	}
}
